// $Id: userdir.h,v 1.5 2000/02/05 20:04:32 siefca Exp $
#ifndef USERDIR__H
#define USERDIR__H

#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>

#define	M_REGULAR_FILE	0
#define	M_DIRECTORY	1

struct cfv {
	char result[MAXPATHLEN];	/* our result			*/
	char *variable;	/* name of an environment variable		*/
	char *home_dir;	/* home directory or NULL for autodetect	*/
	char *home_scd; /* directory if home_dir==NULL and no result	*/
	char *subname;	/* core name of a file/directory		*/
    	char *prefix;	/* prefix when using directly home_dir		*/
	char *suffix;	/* suffix when using directly home_dir		*/
	int mode;	/* expected: M_REGULAR_FILE or M_DIRECTORY	*/
	};

/* reads environment variable. if the path isn't absolute will add $HOME/
 * at the beginning
 * return: 0 - directory exists
 *         -1 - directory doesn't exist
 */
int getusercfv (char *variable, 
		    char *home_dir, 
		    char *user_dir,
		    size_t stringsize);
/* reads the $HOME variable */
int detectcfv(struct cfv *CFV);

/* looks for the config/data file/dir.
 * result: -1 - error - cannot find file/dir 
 *         0 - ok
 *         CFV.result set
 */
int usercfv (struct cfv *CFV);
/* looks for the config/data file/dir.
 * result: -1 - error - cannot read $HOME
 *          0 - ok - if the CFV.result exists, read it. If not create it.
 *              CFV.result set
 */              
int notnullusercfv (struct cfv *CFV);

FILE *fopencfv (struct cfv *CFV, const char *mode);
FILE *maynullfopencfv (struct cfv *CFV, const char *mode);
FILE *notnullfopencfv (struct cfv *CFV, const char *mode);

#endif
